if not IsTrialAccount() then --check for paid account
	local enabled = 1
	local fishing = nil
	local formingRaid = nil
	local f2piGroup = nil
	local askers = {}
	local passLeadTo

	local f = CreateFrame("frame")

	f:RegisterEvent("CHAT_MSG_WHISPER")
	f:RegisterEvent("PARTY_MEMBERS_CHANGED")

	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF" .. F2PLoc.i["F2PI_LOADED"] .. "|r")
	--[[
	local msg = "[F2PI] Invite addon enabled. Whisper me 'inv' to request an invite to a party."
	F2PChat_RouteChatMessage(msg)  --send via addon
	F2PChat_FormatIncoming(msg, F2PAddonGlobalVars.myName) --print sent message
	--]]
	local function F2PI_FilterOutgoing(self, event, ...)
		local msg = ...
		if msg:match("%[F2PI%]") then
			return true
		else
			return false
		end
	end

	local function F2PI_FilterIncoming(self, event, ...)
		local msg = ...
--		if msg:match("^inv$") or msg:match("^lead$") or msg:match("^raid$") or msg:match("^close$") or msg:match("%[F2PI%]") then
		if msg:match("^inv$") or msg:match("^lead$") or msg:match("^close$") or msg:match("%[F2PI%]") then
			return true
		else
			return false
		end
	end

	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", F2PI_FilterOutgoing)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", F2PI_FilterOutgoing)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", F2PI_FilterIncoming)

	f:SetScript("OnEvent", function(self, event, ...)
		if event == ("CHAT_MSG_WHISPER") then
			local msg, sender, _, _, _, flags = ...
			if not (flags == "GM") or (not IsInGuild(sender)) then
				if (not F2PChat_IsBlocked(sender, 10)) then
					if (enabled) then
			
						--find out if you are either queued for BGs or LFD, or are in a BG/dungeon after queueing.
						local busy = false
						if (GetLFGMode() ~= nil) and (GetLFGMode() ~= "abandonedInDungeon") then
							busy = true
						end
						for x = 1, GetMaxBattlefieldID() do
							if GetBattlefieldStatus(x) ~= "none" then
								busy = true
							end
						end
		
						if not msg:match("\[F2PI\]") then --stop the addons getting into a loop of messaging each other
							-- if 'inv' was in the message, but was not it's only content; or the words 'group' or 'party' were used, indicating that the sender might have asked for a group.
							if ((msg:lower():match("inv")) and (not msg:lower():match("^inv$"))) or (msg:lower():match("group")) or (msg:lower():match("party")) then
								SendChatMessage(F2PLoc.i["CLARIFY_COMMAND"], "WHISPER", nil, sender)

							-- specific 'inv' command received
							elseif msg:lower():match("^inv$") then
								--if not using BG/LFD, not yet in a party, or is leader of a party
								if (not busy) and ((not UnitExists("party1")) or IsPartyLeader("player")) then
									--switch over to a raid to make space for additional members if we're at the party size limit
									if (GetNumPartyMembers() == 4) and (not UnitInRaid("player")) then
										ConvertToRaid()
									end
									tinsert(askers, sender)
									InviteUnit(sender)
									if (not fishing) then
										---[[
										SendChatMessage(F2PLoc.i["ACCEPTED_COMMANDS_1"], "WHISPER",nil, sender)
										SendChatMessage(F2PLoc.i["ACCEPTED_COMMANDS_2"], "WHISPER", nil, sender)
										SendChatMessage(F2PLoc.i["ACCEPTED_COMMANDS_3"], "WHISPER", nil, sender)
										SendChatMessage(F2PLoc.i["ACCEPTED_COMMANDS_4"], "WHISPER", nil, sender)
										--]]
									elseif (fishing) then
										SendChatMessage(F2PLoc.i["FISHING_COMP_MODE"], "WHISPER", nil, sender)
									end
								elseif ( busy or (UnitExists("party1") and not IsPartyLeader("player")) ) then
									SendChatMessage(F2PLoc.i["BUSY_RESPONSE"], "WHISPER", nil, sender)
								end
	
							--'lead' command received
							elseif msg:lower():match("^lead$") and (not fishing) and UnitInParty(sender) then
								if (not busy) and UnitExists("party1") and IsPartyLeader("player") and UnitInParty(sender) then
									passLeadTo = sender
									SendChatMessage(string.format(F2PLoc.i["LEADER"], sender), "PARTY", nil, sender)
								elseif (not busy) and not (UnitExists("party1") or UnitInParty(sender)) then
									SendChatMessage(F2PLoc.i["NOT_LEADING"], "WHISPER", nil, sender)
								end
							
							--'raid' command received
							--elseif msg:lower():match("^raid$") and (not fishing) and UnitInParty(sender) then
								--formingRaid = 1
								--SendChatMessage(F2PLoc.i["LIMIT_REMOVED"], "PARTY", nil, sender)
							
							--'close' command received
							elseif msg:lower():match("^close$") and (not fishing) and UnitInParty(sender) then
								--print("close command received.")
								F2PI_CloseGroup(passLeadTo)
							end
						end
					elseif (not enabled) and (not msg:match("\[F2PI\]")) and ( (msg:lower():match("inv")) )  then
						SendChatMessage(F2PLoc.i["AUTO_DISABLED"], "WHISPER", nil, sender)
					end
				else
					SendChatMessage(F2PLoc.i["LEVEL_LIMIT"], "WHISPER", nil, sender)
				end
			end
		
		elseif event == ("PARTY_MEMBERS_CHANGED") and (enabled) then
		
			--if we have reached the party limit, and no-one has asked for a raid sized group, pass lead and leave the group
--			if (f2piGroup == 1) and (GetNumRaidMembers() == 6) and (not formingRaid) and (not fishing) then
			if (f2piGroup == 1) and (GetNumRaidMembers() == 6) and (not fishing) then
				--print("group size hit 6")
				F2PI_CloseGroup(passLeadTo)
			
			--if anyone asked for a group
			elseif #askers > 0 then
				--check if the person who joined is one of them
				for x = 1, #askers do
					if UnitInParty(askers[x]) then
						f2piGroup = 1  --mark this as an F2PI formed group if so
					end
				end
			
				--if it is...
				if f2piGroup then
					--and they're the first to join...
					if (GetNumPartyMembers() == 1) then
						passLeadTo = UnitName("party1")  --will be passing lead to them when the group closes
					end
				end

			--if you're no longer in a party, reset the function's flags
			elseif (not UnitExists("party1")) then
				fishing = nil
				formingRaid = nil
				f2piGroup = nil
				askers = {}
				passLeadTo = nil
			end
		end
	end	
	)

	function F2PI_CloseGroup(newLead)
		if (GetNumRaidMembers() == 6) then
			SendChatMessage(F2PLoc.i["QUEUEING_AS_RAID"], "RAID", nil)
		end
		local partyList = {}
		if UnitInRaid("player") then
			for x = 1, GetNumRaidMembers() do
				local y = GetRaidRosterInfo(x)
				if y ~= UnitName("player") then
					if y == newLead then
						y = y.." (leader)"
					end
					tinsert(partyList, y)
				end
			end
		elseif not UnitInRaid("player") then
			for x = 1, GetNumPartyMembers() do
				local y = UnitName("party"..x)
				if y ~= UnitName("player") then
					if y == newLead then
						y = y.." (leader)"
					end
					tinsert(partyList, y)
				end
			end
		end
		local msg = F2PLoc.i["GROUP_FORMED"] .. table.concat(partyList, ", ")
		F2PChat_RouteChatMessage(msg)  --send via addon
		F2PChat_FormatIncoming(msg, F2PAddonGlobalVars.myName) --print sent message
		PromoteToLeader(newLead, 1)
		LeaveParty()
	end

	local commandTable = {  --create the data structure that the slash commands work from
		["fish"] = function()	
			if fishing == 1 then
				fishing = nil
				print(F2PLoc.i["FISHING_MODE_DISABLED"])
			else
				fishing = 1
				print(F2PLoc.i["FISHING_MODE_ENABLED"])
			end
		end,
		["default"] = function()
			if enabled == 1 then
				enabled = nil
				--[[]]if F2PAddonGlobalVars.verbose then print("[F2PI] disabled") end
				local msg = F2PLoc.i["MANUALLY_DISABLED"]
				F2PChat_RouteChatMessage(msg)  --send via addon
				F2PChat_FormatIncoming(msg, F2PAddonGlobalVars.myName) --print sent message
			else
				enabled = 1
				--[[]]if F2PAddonGlobalVars.verbose then print("[F2PI] enabled") end
				local msg = F2PLoc.i["MANUALLY_ENABLED"]
				F2PChat_RouteChatMessage(msg)  --send via addon
				F2PChat_FormatIncoming(msg, F2PAddonGlobalVars.myName) --print sent message
			end
		end,
	}

	local function runSlashCommand(message, cmdTable)
		local command, parameters = string.split(" ", message, 2)
		if (command == nil) or (command == "") then
			commandTable.default()
		elseif command == "fish" then
			commandTable.fish()
		end
	end

	SLASH_F2PI1 = "/f2pi"
	SlashCmdList["F2PI"] = function(txt)
		runSlashCommand(txt, commandTable)
	end

else --for trials
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF00FF" .. F2PLoc.i["ON_TRIAL"] .. "|r")
end
